<?php

declare(strict_types=1);

namespace Drupal\murmurations\Attribute;

use Drupal\Component\Plugin\Attribute\Plugin;

/**
 * Defines a Murmruations attribute.
 *
 * Plugin Namespace: Plugin\murmurations
 *
 * @ingroup migration
 */
#[\Attribute(\Attribute::TARGET_CLASS)]
class Murmurations extends Plugin {

  /**
   * Constructs a migrate destination plugin attribute object.
   *
   * @param string $id
   *   A unique identifier for the destination plugin.
   * @param bool $label
   * @param string $schema
   *   the official string of the schema and version number.
   * @param string $profile_path
   *   The internal path or path pattern.
   * @param string $config
   *   The route id for the config page
   * @param string $entity_type
   *   The machine name of the entity (optional)
   * @param string $default_aggregator
   *   Url to the default aggregator.
   */
  public function __construct(
    public readonly string $id,
    public bool $label,
    public string $schema,
    public string $profile_path,
    public string $config,
    public string $default_aggregator,
    public ?string $entity_type,
  ) {
  }

}
